Bug 1460597 - [RFE][GSS]Gluster process should use ports above reserved ports (above 1024) [NEEDINFO]
[RFE][GSS]Gluster process should use ports above reserved ports (above 1024)
Status: NEW
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: core (Show other bugs)
3.1
All Unspecified
unspecified Severity high
: ---
: ---
Assigned To: Vijay Bellur
Rahul Hinduja
: FutureFeature, ZStream
Depends On:
Blocks: 1408949 RHGS-usability-bug-GSS
  Show dependency treegraph
 
Reported: 2017-06-12 03:09 EDT by Abhishek Kumar
Modified: 2017-09-28 13:14 EDT (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
sankarshan: needinfo? (asrivast)
amukherj: needinfo? (rtalur)


Attachments (Terms of Use)

  None (edit)
Description Abhishek Kumar 2017-06-12 03:09:09 EDT
Description of problem:

Glusterd should use ports above reserved ports (above 1024)

Version-Release number of selected component (if applicable):

RHGS 3.2

Actual results:

Many instances has been found that gluster is allocating ports below 1024 which are creating a lot of issue with other application like nfs or openshift which requires those reserved ports to function normally.

Expected results:

Gluster should always allocate ports above 1024.

Additional info:

~~~
tcp        0      0 10.100.10.76:925        10.100.30.109:49154     ESTABLISHED 12971/glusterfs
tcp        0      0 10.100.10.76:925        10.100.30.109:49154     ESTABLISHED 12971/glusterfs
tcp        0      0 10.100.10.76:883        10.100.30.109:49160     ESTABLISHED 12971/glusterfs
~~~
Comment 3 Raghavendra Talur 2017-06-12 04:16:49 EDT
The problem mentioned in the original bug description about openshift and gluster trying to use same ports is a problem that can't be solved as it is the problem of limited resources and more demand.

To fix the problem that is mentioned in comment 2 about gluster using a port that is used by rquotad, you can use the ip_local_reserved_ports feature of linux kernel as mentioned in https://www.kernel.org/doc/Documentation/networking/ip-sysctl.txt . We follow the same model that is used by linux kernel for port allocation. We don't bind to a port that is listed in the reserved ports list. Specifying 875 port in this list would ensure that gluster client processes don't use it.

There is a certain trust logic in Gluster that requires binding to a port under 1024 and it will take a few more releases before we can completely get rid of it.
Comment 4 Atin Mukherjee 2017-06-12 08:03:40 EDT
This issue is not anything specific to GlusterD. Moving it to core.
Comment 7 Raghavendra Talur 2017-06-16 06:30:26 EDT
I spoke to Atin and others too. There is no way to do this in our current version.

I still stand by my original answer that it is up to the admin to use ip_local_reserved_ports option to handle these errors and does not need any code change.

Note You need to log in before you can comment on or make changes to this bug.